package net.tomatentum.cutin;

import java.util.Collection;
import java.util.HashSet;
import java.util.Set;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import net.tomatentum.cutin.container.MethodContainer;

public class ProcessorMethodExecutor<I extends Object> implements MethodExecutor, ProcessorContainer<I> {

    private Logger logger = LoggerFactory.getLogger(getClass());

    private MethodContainer<I> methodContainer;
    private Set<MethodProcessor<I>> processors;

    public ProcessorMethodExecutor(MethodContainer<I> methodContainer) {
        this.methodContainer = methodContainer;
        this.processors = new HashSet<>();
    }

    @Override
    public ProcessorContainer<I> addProcessor(MethodProcessor<I> processor) {
        processors.add(processor);
        return this;
    }

    @Override
    public Collection<MethodProcessor<I>> processor() {
        return this.processors;
    }

    @Override
    public void handle(Object context) {
        logger.debug("Handling {} context ", context);
        processors.forEach(x -> x.process(context, methodContainer));
    }
    
}
